<?php
// File: $Id: bbcode_ref.php,v 1.5 2004/04/22 12:35:08 drak Exp $ $Name: HEAD $
// ----------------------------------------------------------------------
// PostNuke Content Management System
// Copyright (C) 2001 by the PostNuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// Based on:
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Original Author of file: Francisco Burzi
// Purpose of file:
// ----------------------------------------------------------------------

?>

<html>
<head>
<style type="text/css">
<!--

<?php
echo "TD {font-size: 10pt; font-family: $site_font}\n";
echo "BODY {font-size: 10pt; font-family: $site_font}\n";
echo "-->\n</style>\n";
echo "<title>$sitename</title>\n";
?>
</style>
</head>
<body>
<div style="text-align:center">W H A T &nbsp;&nbsp;&nbsp;&nbsp; I S &nbsp;&nbsp;&nbsp;&nbsp; B B C O D E ?</div>
<p>BBCode is a variation on the HTML tags you may already be familiar with.  Basically, it allows you to add functionality or style 
to your message that would normally require HTML.  You can use BBCode even if HTML is not enabled for the forum you are using.  
You may want to use BBCode as opposed to HTML, even if HTML is enabled for your forum, because there is less coding required and it 
is safer to use (incorrect coding syntax will not lead to as many problems).
</p>
<strong>Current BBCodes:</strong>
<table border="0" cellpadding="4" border="0" cellspacing="1" width="100%">
	<tr style="background-color:<?php echo $bgcolor2?>">
		<td>
			<span style="color:<?php echo $textcolor2; ?>">URL Hyperlinking</span>
		</td>
	</tr>
	<tr style="background-color:<?php echo $bgcolor1?>">
		<td>
			<p>NEW! If BBCode is enabled in a forum, you no longer need to use the [URL] code to create a hyperlink.  
			Simply type the complete URL in either of the following manners and the hyperlink will be created automatically:
			<span style="color:silver">
			<ul>
				<li>http://www.yourURL.com</li>
				<li>www.yourURL.com</li>
			</ul>
			</span>
			Notice that you can either use the complete http:// address or shorten it to the www domain.  If the site does not begin with "www", 
			you must use the complete "http://" address.  Also, you may use https and ftp URL prefixes in auto-link mode (when BBCode is ON).</p>
			<p>
			The old [URL] code will still work, as detailed below.
			
			Just encase the link as shown in the following example (BBCode is in <span style="color:#FF0000">red</span>).
			<p>
			<span style="color:red">[url]</span>www.totalgeek.org<span style="color:red">[/url]</span>
			<p></center>
			NEW! You can now have true hyperlinks using the [url] code.  Just use the following format:
			<br /><center>
			<span style="color:red">[url=http://www.totalgeek.org]</span>totalgeek.org<span style="color:red">[/url]</span>
			</center><p>
			In the examples above, the BBCode automatically generates a hyperlink to the URL that is encased.  It will also ensure that the link is opened in a new window when the user clicks on it. Note that the "http://" part of the URL is completely optional. In the second example above, the URL will hypelink the text to whatever URL you provide after the equal sign.  Also note that you should NOT use quotation marks inside the URL tag.
			</span>
		</td>
	</tr>
	<tr style="background-color:<?php echo $bgcolor2?>">
		<td>
			<span style="color:<?php echo $textcolor2; ?>">Email Links</span>
		</td>
	</tr>
	<tr style="background-color:<?php echo $bgcolor1?>">
		<td>
		To add a hyperlinked email address within your message, just encase the email address as shown in the following example 
		(BBCode is in <span style="color:red">red</span>).
		<p>
			<span style="color:red">[email]</span>james@totalgeek.org<span style="color:red">[/email]</span>
		</p>
		In the example above, the BBCode automatically generates a hyperlink to the email address that is encased.
		</td>
	</tr>
	<tr style="background-color:<?php echo $bgcolor2?>">
		<td>
			<span style="color:<?php echo $textcolor2; ?>">Bold and Italics</span>
		</td>
	</tr>
	<tr style="background-color:<?php echo $bgcolor1?>">
		<td>
			You can make italicized text or make text bold by encasing the applicable sections of your text with either the [b] 
			[/b] or [i] [/i] tags.
			<p>Hello, <span style="color:red">[b]</span><strong>James</strong><span style="color:red">[/b]</span><br />
			Hello, <span style="color:red">[i]</span><I>Mary</I><span style="color:red">[/i]</span></p>
		</td>
	</tr>
	<tr style="background-color:<?php echo $bgcolor2?>">
		<td>
			<span style="color:<?php echo $textcolor2; ?>">Bullets/Lists</span>
		</td>
	</tr>
	<tr style="background-color:<?php echo $bgcolor1?>">
		<td>
			You can make bulleted lists or ordered lists (by number or letter).<br />
			Unordered, bulleted list:<br />
			<span style="color:red">[list]</span><br />
			<br />
			<span style="color:red">[*]</span> This is the first bulleted item.<br />
			<span style="color:red">[*]</span> This is the second bulleted item.<br />
			<span style="color:red">[/list]</span>
			<br />
			This produces:
			<ul>
			<li> This is the first bulleted item.</li>
			<li> This is the second bulleted item.</li>
			</ul>
			Note that you must include a closing [/list] when you end each list.<br />
			Making ordered lists is just as easy.  Just add either [LIST=A] or [LIST=1].  Typing [List=A] will produce a list from A to Z.  
			Using [List=1] will produce numbered lists.
			<br />
			Here's an example:
			<br />
			<span style="color:red">[list=A]</span>
			<br />
			<span style="color:red">[*]</span> This is the first bulleted item.<br />
			<span style="color:red">[*]</span> This is the second bulleted item.<br />
			<span style="color:red">[/list]</span>
			<br />
			This produces:
			<ol type="a">
			<li>This is the first bulleted item.</li>
			<li>This is the second bulleted item.</li>
			</ul>
		</td>
	</tr>
	<tr style="background-color:<?php echo $bgcolor2?>">
		<td>
			<span style="color:<?php echo $textcolor2; ?>">Adding Images</span>
		</td>
	</tr>
	<tr style="background-color:<?php echo $bgcolor1?>">
		<td>
			To add a graphic within your message, just encase the URL of the graphic image as shown in the following example 
			(BBCode is in <span style="color:red">red</span>).<br />
			<span style="color:red">[img]</span>http://www.yoursite.com/images/image.gif<span style="color:red">[/img]</span><br />
			In the example above, the BBCode automatically makes the graphic visible in your message.  Note: the "http://" part of 
			the URL is REQUIRED for the <span style="color:red">[img]</span> code.  Also note: some UBB forums may disable the 
			<span style="color:red">[img]</span> tag support to prevent objectionable images from being viewed.
			</span>
		</td>
	</tr>
	<tr style="background-color:<?php echo $bgcolor2?>">
		<td>
			<span style="color:<?php echo $textcolor2; ?>">Quoting Other Messages</span>
		</td>
	</tr>
	<tr style="background-color:<?php echo $bgcolor1?>">
		<td>
			To reference something specific that someone has posted, just cut and paste the applicable verbiage and enclose it 
			as shown below (BBCode is in <span style="color:red">red</span>). <span style="color:red">[QUOTE]</span>Ask not what 
			your country can do for you....<br />ask what you can do for your country.<span style="color:red">[/QUOTE]</span>
			In the example above, the BBCode automatically blockquotes the text you reference.</span>
		</td>
	</tr>
	<tr style="background-color:<?php echo $bgcolor2?>">
		<td>
			<span style="color:<?php echo $textcolor2; ?>">Code Tag</span>
		</td>
	</tr>
	<tr style="background-color:<?php echo $bgcolor1?>">
		<td>
			Similar to the Quote tage, the Code tag adds some &lt;PRE&gt; tags to preserve formatting.  This useful for displaying 
			programming code, for instance.
			<span style="color:red">[CODE]</span>#!/usr/bin/perl
			<p>
			print "Content-type: text/html\n\n";
			<br />
			print "Hello World!";
			</p>
			<span style="color:red">[/CODE]</span>
			In the example above, the BBCode automatically blockquotes the text you reference and preserves the formatting of the 
			coded text.</span>
		</td>
	</tr>
</table>
</blockquote>
<br /><br />
<span style="color:<?php echo $bgcolor2?>" >Of Note
<br />
You must not use both HTML and BBCode to do the same function.  Also note that the BBCode is not case-sensitive (thus, you could use <span style="color:red">[URL]</span> or <span style="color:red">[url]</span>).
<span style="color:<?php echo $bgcolor2?>">Incorrect BBCode Usage:</span>
<span style="color:red">[url]</span> www.totalgeek.org <span style="color:red">[/url]</span> - don't put spaces between the bracketed 
code and the text you are applying the code to.
<span style="color:red">[email]</span>james@totalgeek.org<span style="color:red">[email]</span> - the end brackets must include a forward slash (<span style="color:red">[/email]</span>)
</span>
</body>
</html>