<?php
// File: $Id: replypmsg.php,v 1.31 2004/06/28 23:22:42 chestnut Exp $ $Name: HEAD $
// ----------------------------------------------------------------------
// PostNuke Content Management System
// Copyright (C) 2001 by the PostNuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// Based on:
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Original Author of file: Francisco Burzi
// Purpose of file: Part of phpBB integration
//   Copyright (c) 2001 by
//   Richard Tirtadji AKA King Richard (rtirtadji@hotmail.com)
//   Hutdik Hermawan AKA hotFix (hutdik76@hotmail.com)
//   http://www.phpnuke.web.id
// ----------------------------------------------------------------------

if (!defined("LOADED_AS_MODULE")) {
         die ("You can't access this file directly...");
     }

$ModName = basename( dirname( __FILE__ ) );

include 'modules/'.$ModName.'/functions.php';

modules_get_language();

// show message icons (should be configurable)
$show_icons = 1;

if(isset($cancel)) {
    pnRedirect('modules.php?op=modload&name='.$ModName.'&file=index');
}

if (!pnUserLoggedIn()) {
    pnRedirect('user.php');
} else {
    list ($send, $reply, $submit, $delete) = pnVarCleanFromInput('send', 'reply', 'submit', 'delete');
    include('header.php');
    $userdata = pnUserGetVar('uname');

    $dbconn =& pnDBGetConn(true);
    $pntable =& pnDBGetTables();

    if(isset($submit)) {
        list($image,
             $subject,
             $to_user,
             $message) = pnVarCleanFromInput('image',
                                             'subject',
                                             'to_user',
                                             'message');

        if($subject == '') {
            forumerror("0017");
        }

        /* there is always an icon
        if($image == '') {
            forumerror("0018");
        }
        */

        if($message == '') {
            forumerror("0019");
        }

        /* since we use HMTL-display this is not needed
        if(isset($allow_html) == 0 && (isset($html))) {
            $message = htmlspecialchars($message);
        }
        */

        /* since we always use bbcode this is not needed
        if(isset($allow_bbcode) == 1 && (!isset($bbcode))) {
            $message = pn_bbencode($message);
        }
        */

        /* since we use [addsig] this is not needed
        if(isset($sig)) {
        $user_sig = pnUserGetVar('user_sig');
            $message .= "<br />-----------------<br />" . $user_sig;
        }
        */

        $message = pn_bbencode($message);
        $message = nl2br($message);
        if(pnUserLoggedin()) {
            $message .= "[addsig]";
        }

        /* since smilies need image tag allowed this should be configurable
        if(!isset($smile)) {
            $message = smile($message);
        }
        */

        $time = date("Y-m-d H:i");
        $column = &$pntable['users_column'];
        $res =& $dbconn->Execute("SELECT $column[uid]
                               FROM $pntable[users]
                               WHERE $column[uname]='" . pnVarPrepForStore($to_user) . "'
                                 AND $column[uid] != 1");

        list($to_userid) = $res->fields;
        $res->Close();

        if ($to_userid == "") {
            OpenTable();
            echo "<div style=\"text-align:center\"><span class=\"pn-normal\">"._USERNOTINDB."<br />"
                .""._CHECKNAMEANDTRY."<br /><br />"
                .""._GOBACK."</span></div>";
            CloseTable();
            include("footer.php");
        } else {
            $column = &$pntable['priv_msgs_column'];
            $nextid = $dbconn->GenId($pntable['priv_msgs_column']);
            $from_uid = pnUserGetVar('uid');

            $sql = "INSERT INTO $pntable[priv_msgs]
                      ($column[msg_id],
                       $column[msg_image],
                       $column[subject],
                       $column[from_userid],
                       $column[to_userid],
                       $column[msg_time],
                       $column[msg_text])
                    VALUES
                      ('" . pnVarPrepForStore($nextid). "',
                      '" . pnVarPrepForStore($image) . "',
                      '" . pnVarPrepForStore($subject) . "',
                      '" . pnVarPrepForStore($from_uid) . "',
                      '" . pnVarPrepForStore($to_userid) . "',
                      '" . pnVarPrepForStore($time) . "',
                      '" . pnVarPrepForStore($message) . "')";
            $res =& $dbconn->Execute($sql);
            if($dbconn->ErrorNo()<>0) {
                error_log("DB Error: " . $dbconn->ErrorMsg());
                error_log("SQL was: $sql");
                forumerror("0020");
            }
            OpenTable();
            echo "<div style=\"text-align:center\"><span class=\"pn-normal\"><strong>"._MSGPOSTED."<strong></span><br /><a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=$ModName&amp;file=index\"><strong>"._RETURNTOPMSG."</strong></a></div>";
            CloseTable();
        }
    }

    if (isset($delete)) {
        list ($msg_id, $total_messages, $status) = pnVarCleanFromInput('msg_id', 'total_messages', 'status');
        if (isset($msg_id)) {
            if (is_array($msg_id)) {
                // delete multiple messages for a list
                $column = &$pntable['priv_msgs_column'];
                for ($i = 0; $i < $total_messages; $i++) {
                    if (isset($msg_id[$i])) {
                        $from_uid = pnUserGetVar('uid');
                        $sql = "DELETE FROM $pntable[priv_msgs]
                                WHERE $column[msg_id] = '" . pnVarPrepForStore($msg_id[$i]) ."'
                                AND $column[to_userid] = '" . pnVarPrepForStore($from_uid) ."'";
                        $res =& $dbconn->Execute($sql);
                        if ($dbconn->ErrorNo()<>0) {
                            error_log("DB Error: " . $dbconn->ErrorMsg());
                            forumerror("0021");
                        } else {
                            $status = 1;
                        }
                    }
                }
            } else {
                // delete a single message
                $column = &$pntable['priv_msgs_column'];
                $from_uid = pnUserGetVar('uid');
                $sql = "DELETE FROM $pntable[priv_msgs]
                        WHERE $column[msg_id] = '" . pnVarPrepForStore($msg_id) ."'
                        AND $column[to_userid] = '" . pnVarPrepForStore($from_uid) ."'";
                $res =& $dbconn->Execute($sql);
                if ($dbconn->ErrorNo() != 0) {
                    error_log("DB Error: " . $dbconn->ErrorMsg());
                    forumerror("0021");
                } else {
                    $status = 1;
                }
            }
            if ($status) {
                OpenTable();
                echo "<div style=\"text-align:center\"><span class=\"pn-normal\"><strong>"._MSGDELETED."</strong></span><br /><a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=$ModName&amp;file=index\">"._RETURNTOPMSG."</a></div>";
                CloseTable();
            }
        } else {
            OpenTable();
            echo "<div style=\"text-align:center\"><span class=\"pn-normal\"><strong>"._NO_MESSAGE_SELECTED."</strong></span><br /><a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=$ModName&amp;file=index\">"._RETURNTOPMSG."</a></div>";
            CloseTable();
        }
    }

    if (isset($reply) || (isset($send))) {
        $msg_id = pnVarCleanFromInput('msg_id');
        $uname  = pnVarCleanFromInput('uname');
        $dbconn =& pnDBGetConn(true);
        $pntable =& pnDBGetTables();
        if (isset($reply)) {
            $column = &$pntable['priv_msgs_column'];
            $sql = "SELECT $column[msg_image] AS msg_image,
                           $column[subject] AS subject,
                           $column[from_userid] AS from_userid,
                           $column[to_userid] AS to_userid
                    FROM $pntable[priv_msgs]
                    WHERE $column[msg_id] = '". pnVarPrepForStore($msg_id) ."'";
            $result =& $dbconn->Execute($sql);
            if($dbconn->ErrorNo()<>0) {
                error_log("DB Error: " . $dbconn->ErrorMsg());
                forumerror("0022");
            }
            //ADODBtag MoveNext ->fet_chrow(DB_FETCHMODE_ASSOC
            $row = $result->GetRowAssoc(false);
            $result->MoveNext();
            if (!$row) {
                forumerror("0023");
            }
            $fromuserdata = get_userdata_from_id($row['from_userid']);
            $touserdata = get_userdata_from_id($row['to_userid']);
            $user_id = pnUserGetVar('uid');
            if (pnUserLoggedIn() && ($user_id != $touserdata['pn_uid']) ) {
                forumerror("0024");
            }
        }
        OpenTable();
        print '<div style="text-align:center"><span class="pn-pagetitle">'._USENDPRIVATEMSG.'</span></div>';
        CloseTable();

        echo "<form action=\"modules.php\" method=\"post\" name=\"coolsus\">"
            ."<input type=\"hidden\" name=\"op\" value=\"modload\">"
            ."<input type=\"hidden\" name=\"name\" value=\"$ModName\">"
            ."<input type=\"hidden\" name=\"file\" value=\"replypmsg\">"
            ."<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" align=\"center\" valign=\"top\" width=\"100%\"><tr><td>"
            ."<table border=\"0\" cellpadding=\"3\" cellspacing=\"1\" width=\"100%\">"
            ."<tr bgcolor=\"$bgcolor2\" align=\"left\">"
            ."<td colspan=2><span class=\"pn-normal\"><strong>"._ABOUTPOSTING.": "._ALLREGCANPOST."</strong></span></td>"
            ."</tr>"
            ."<tr align=\"left\">"
            ."<td bgcolor=\"$bgcolor3\" width=\"25%\"><span class=\"pn-normal\"><strong>"._TO.":</strong></span></td>";
        if (isset($reply)) {
            echo "<td bgcolor=\"$bgcolor3\"><input type=\"hidden\" name=\"to_user\" value=\"" . pnVarPrepForDisplay($fromuserdata['pn_uname']) . "\"><span class=\"pn-normal\">" . pnVarPrepForDisplay($fromuserdata['pn_uname']) . "</span></td>";
        } else {
            if (isset($uname)) {
                echo "<td bgcolor=\"$bgcolor3\"><input name=\"to_user\" SIZE=\"26\" maxlength=\"25\" value=\"" . pnVarPrepForDisplay($uname) . "\">";
            } else {
                echo "<td bgcolor=\"$bgcolor3\"><input name=\"to_user\" SIZE=\"26\" maxlength=\"25\">";
            }
            echo "</td>";
        }
        echo "</tr>"
            ."<tr align=\"left\">"
            ."<td bgcolor=\"$bgcolor3\" width=\"25%\"><span class=\"pn-normal\"><strong>"._SUBJECT.":</strong></span></td>";
        if (isset($reply)) {
            echo "<td  bgcolor=\"$bgcolor3\"><input type=\"TEXT\" name=\"subject\" value=\""._RE.": " . pnVarPrepForDisplay($row['subject']) . "\" SIZE=\"70\" MAXLENGTH=\"100\"></td>";
        } else {
            echo "<td  bgcolor=\"$bgcolor3\"><input type=\"TEXT\" name=\"subject\" SIZE=\"70\" MAXLENGTH=\"100\"></td>";
        }
        echo "</tr>";

        if ($show_icons == 1){
            echo "<tr align=\"left\" valign=\"top\">"
                ."<td  bgcolor=\"$bgcolor3\" width=\"25%\"><span class=\"pn-normal\"><strong>"._MESSAGEICON.":</strong></span></td>"
                ."<td  bgcolor=\"$bgcolor3\">";

            $handle=opendir("images/smilies");
            while ($file = readdir($handle)) {
                $filelist[] = $file;
            }
            asort($filelist);
            $a = 1;
            $count = 1;
            echo "<table><tr>";
            while (list ($key, $file) = each ($filelist)) {
                ereg(".gif|.jpg",$file);
                if ($file != "." && $file != ".." && $file != "index.html" && $file != "CVS") {
                    $sel = "";
                    //Determine if image should be checked.
                    if (!isset($row)){
                        if ($a == 1){
                            $sel = "checked";
                        }
                    } else {
                        if (($row['msg_image'] != "" && $file == $row['msg_image']) || ($row['msg_image'] == "" && $a == 1)) {
                            $sel = "checked";
                        }
                    }
                    echo "<td><input type='radio' name='image' value=\"$file\" $sel><img src=\"images/smilies/$file\" border=\"0\">&nbsp;</td>";
                    $a++;
                }
                if ($count >= 10) {
                    $count=1;
                    echo "</tr><tr>";
                }
                $count++;
            }
            echo "</tr></table>";
            echo "</td></tr>";
        } else {
            echo "<input type='hidden' name='image' value='icon1.gif'>";
        }

        echo "<tr align=\"left\" valign=\"top\">"
            ."<td bgcolor=\"$bgcolor3\" width=\"25%\"><span class=\"pn-normal\"><strong>"._MESSAGE.":</strong></span><br /><br />";

        echo "<span class=\"pn-normal\">(<a class=\"pn-normal\" href=\"modules/$ModName/bbcode_ref.php\" TARGET=\"blank\">"._BB_CODE."</a>)</span>";

        if (isset($reply)) {
            $column = &$pntable['priv_msgs_column'];
            $column2 = &$pntable['users_column'];
            $sql = "SELECT $column[msg_text] AS msg_text,
                            $column[msg_time] AS msg_time,
                            $column2[uname] AS uname
                    FROM $pntable[priv_msgs], $pntable[users]
                    WHERE $column[msg_id] = '" . pnVarPrepForStore($msg_id) . "'
                    AND $column[from_userid] = ".$column2['uid'];
            $result =& $dbconn->Execute($sql);
            if($dbconn->ErrorNo()<>0) {
                error_log("DB Error: " . $dbconn->ErrorMsg());
                $reply = "Error Contacting database. Please try again.\n";
            } else {
                //ADODBtag MoveNext ->fet_chrow(DB_FETCHMODE_ASSOC
                $row = $result->GetRowAssoc(false);
                $result->MoveNext();
                $text = desmile($row['msg_text']);
                $text = preg_replace('/(<br[ \/]*?>)/i', "", $text);
                $text = pnVarPrepHTMLDisplay($text);
                $text = pn_bbdecode($text);
                $text = eregi_replace("\[addsig]", "", $text);

                $row['msg_time'] = mktime( substr($row['msg_time'], 11, 2),     // hour
                                            substr($row['msg_time'], 14, 2),    // minute
                                            '0',                                // second
                                            substr($row['msg_time'], 5, 2),     // month
                                            substr($row['msg_time'], 8, 2),     // day
                                            substr($row['msg_time'], 0, 4));    // year

                $reply = "[quote]\n$row[uname] "._WROTE." "._ON." ". ml_ftime(_DATETIMEBRIEF, GetUserTime($row['msg_time'])) .":\n$text\n[/quote]";
            }
        }
        echo "</span></td>"
            ."<td bgcolor=\"$bgcolor3\"><textarea name=\"message\" rows=\"10\" cols=\"80\" wrap=\"virtual\">";
        if (isset($reply)) {
            echo $reply;
        }
        echo "</textarea><span class=\"pn-normal\"><br />"._ALLOWEDHTML."<br />";
        $AllowableHTML = pnConfigGetVar('AllowableHTML');
        while (list($key, $access, ) = each($AllowableHTML)) {
            if ($access > 0) echo " &lt;".$key."&gt;";
        }

        // PostNuke: make this a user set option 0=on / 1=off
        /* since there are no message icons we don't need this
        if($smilies==1) { echo "";  } else {
            putitems();
        } // PostNuke: end
        */

        echo "</span></td>"
            ."</tr>";

        // PostNuke: remove last of icon/smiley stuff
        /* not needed right now
        if($smilies==1) {
        echo "";
        }
        else {

        echo "<tr align=\"left\">"
            ."<td bgcolor=\"$bgcolor3\" width=\"25%\"><span class=\"pn-normal\">"._OPTIONS.":</span></td>"
            ."<td bgcolor=\"$bgcolor1\">";
        if($allow_html == 1) {
            echo "<input type=\"CHECKBOX\" name=\"html\"><span class=\"pn-normal\">"._HTMLDISSABLE."</span><br />";
        }
        if($allow_bbcode == 1) {
            echo "<input type=\"CHECKBOX\" name=\"bbcode\"><span class=\"pn-normal\">"._BBCODEDISSABLE."</span><br />";
        }

        echo "<input type=\"CHECKBOX\" name=\"smile\"><span class=\"pn-normal\">"._SMILEDISSABLE."</span><br />"
        ."</td>"
            ."</tr>";
        }
        */
        // PostNuke: end

        if(!isset($msg_id)) {
            $msg_id = '';
        }

        echo "<tr>"
            ."<td bgcolor=\"$bgcolor2\" colspan=\"2\" align=\"left\">"
            ."<input type=\"hidden\" name=\"msg_id\" value=\"$msg_id\">"
            ."<input type=\"submit\" name=\"submit\" value=\""._SUBMIT."\">&nbsp;";
        if (isset($reply)) {
            echo "&nbsp;<input type=\"submit\" name=\"cancel\" value=\""._CANCELREPLY."\">";
        } else {
            echo "&nbsp;<input type=\"submit\" name=\"cancel\" value=\""._CANCELSEND."\">";
        }
        echo "</td>"
            ."</tr>"
            ."</table></td></tr></table>"
            ."</form>"
            ."<br />";
    }
}
include('footer.php');

?>