<?php // File: $Id: readpmsg.php,v 1.24 2004/08/13 12:28:22 landseer Exp $ $Name: HEAD $
// ----------------------------------------------------------------------
// PostNuke Content Management System
// Copyright (C) 2001 by the PostNuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// Based on:
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Original Author of file: Francisco Burzi
// Purpose of file: Part of phpBB integration
//   Copyright (c) 2001 by
//   Richard Tirtadji AKA King Richard (rtirtadji@hotmail.com)
//   Hutdik Hermawan AKA hotFix (hutdik76@hotmail.com)
//   http://www.phpnuke.web.id
// ----------------------------------------------------------------------
// Changelog
// yyyy-mm-dd  username  description
// 2001-11-21  eugeniobaldi    Fixed brosing more than 2 messages 
// ----------------------------------------------------------------------

if (!defined("LOADED_AS_MODULE")) {
    die ("You can't access this file directly...");
}

$ModName = basename( dirname( __FILE__ ) );

include 'modules/'.$ModName.'/functions.php';

modules_get_language();

//$forumpage = 1;

if (!pnUserLoggedIn()) {
    pnRedirect('user.php');
} else {
    include('header.php');

    list($start,$total_messages) = pnVarCleanFromInput('start','total_messages');

	$dbconn =& pnDBGetConn(true);
	$pntable =& pnDBGetTables();

    $userdata = pnUserGetVar('uid');
    $column = &$pntable['priv_msgs_column'];
    //$sql = buildSimpleQuery ('priv_msgs', array ('msg_id', 'msg_image', 'subject', 'from_userid', 'to_userid', 'msg_time', 'msg_text', 'read_msg'), "$column[to_userid]='" . pnVarPrepForStore($userdata) . "'", '', 1, pnVarPrepForStore($start));
	$sql = "SELECT $column[msg_id] AS \"msg_id\",
					$column[msg_image] AS \"msg_image\",
					$column[subject] AS \"subject\",
					$column[from_userid] AS \"from_userid\",
					$column[to_userid] AS \"to_userid\",
					$column[msg_time] AS \"msg_time\",
					$column[msg_text] AS \"msg_text\",
					$column[read_msg] AS \"read_msg\"
			FROM $pntable[priv_msgs]
            WHERE $column[to_userid]='" . (int)pnVarPrepForStore($userdata) . "'";

    $resultID =& $dbconn->SelectLimit($sql,1,$start);
    if($dbconn->ErrorNo()<>0) {
        error_log("DB Error: " . $dbconn->ErrorMsg());
        echo $dbconn->ErrorMsg() . "<br />";
        forumerror(0005);
    }

    $myrow = $resultID->GetRowAssoc(false);
    $resultID->MoveNext();
    // Turn this time string into a UNIX timestamp for use with GetUserTime
    $myrow['msg_time'] = mktime( substr($myrow['msg_time'], 11, 2),     // hour
                                        substr($myrow['msg_time'], 14, 2),    // minute
                                        '0',                                // second
                                        substr($myrow['msg_time'], 5, 2),     // month
                                        substr($myrow['msg_time'], 8, 2),     // day
                                    substr($myrow['msg_time'], 0, 4));    // year

    $column = &$pntable['priv_msgs_column'];
    $sql = "UPDATE $pntable[priv_msgs] 
            SET $column[read_msg]='1' 
            WHERE $column[msg_id]= '" .(int)pnVarPrepForStore($myrow['msg_id']) ."'";
    $result =& $dbconn->Execute($sql);
    if($dbconn->ErrorNo()<>0) {
        error_log("DB Error: " . $dbconn->ErrorMsg());
        echo $dbconn->ErrorMsg() . "<br />";
        forumerror(0005);
    }

    OpenTable();
    echo "<div style=\"text-align:center\"><span class=\"pn-pagetitle\">"._PRIVATEMESSAGE."</span>
           <br />
	   <br />
	    <span class=\"pn-normal\">
	    <strong>
	     <a href=\"modules.php?op=modload&amp;name=$ModName&amp;file=index\">"._INDEX."</a>
	    </strong></span>
	  </div>";
    CloseTable();
    //Cleaned up display - skooter
    echo "<br />"
    ."<table border=\"0\" cellpadding=\"1\" cellspacing=\"0\" valign=\"top\" width=\"100%\"><tr><td>"
    ."<table border=\"0\" cellpadding=\"3\" cellspacing=\"1\" width=\"100%\">"
    ."<tr bgcolor=\"$bgcolor2\" align=\"left\">"
    ."<td width=\"20%\"><span class=\"pn-sub\"><strong>"._FROM."</strong></span></td>"
    ."<td width=\"80%\"><span class=\"pn-sub\"><strong>"._MESSAGE."</strong></span></td>"
    ."</tr>";

    if (!$resultID->EOF) {
        echo "<td bgcolor=\"$bgcolor3\" colspan=\"2\" align=\"center\"><span class=\"pn-normal\">"._DONTHAVEMESSAGES."</span></td></tr>\n";
    } else {
        echo "<tr bgcolor=\"$bgcolor3\" align=\"left\">\n";
        $posterdata = get_userdata_from_id($myrow['from_userid']);
        echo "<td valign=\"top\"><span class=\"pn-normal\"><strong>".pnVarPrepForDisplay($posterdata['pn_uname'])."</strong></span><br /><br />\n";
		/* listed in profile
		if (!empty($posterdata['pn_user_from'])) {
			echo "<span class=\"pn-normal\">"._FROM.": " . pnVarPrepForDisplay($posterdata['pn_user_from']) . "</span><br /><br />\n";
		}
		*/
		if ($posterdata['pn_user_avatar'] != "") {
		  echo "<img src='images/avatar/" . pnVarPrepForDisplay($posterdata['pn_user_avatar']) . "' alt=\"\">\n";
		}
		echo "</td><td><span class=\"pn-sub\">"._SUBJECT.": ";
		if ($myrow['msg_image'] != ""){
			echo "<img src=\"images/smilies/".$myrow['msg_image']."\">&nbsp;";
		}
		echo pnVarPrepForDisplay($myrow['subject'])."</span>&nbsp;&nbsp;&nbsp;"
			."<span class=\"pn-sub\">"._SENT.": ".ml_ftime(_DATETIMEBRIEF, GetUserTime($myrow['msg_time']))."</span>"
			."<hr noshade>\n";
		echo "<span class=\"pn-normal\">\n";

		// bit of a cheat here .. greg.
		$message = eregi_replace("\[addsig]", "<br />-----------------<br />" . nl2br($posterdata['pn_user_sig']), $myrow['msg_text']);

		$message = pn_bbencode($message);

		echo pnVarPrepHTMLDisplay($message) . "</span><br />"
			."<hr noshade>\n"
			."<a href=\"user.php?op=userinfo&amp;uname=" . pnVarPrepForDisplay($posterdata['pn_uname']) . "\"><img src=\"images/global/profile.gif\" border=\"0\" alt=\"\"></a><span class=\"pn-sub\">"._PROFILE."</span>\n";
		if($posterdata['pn_femail'] != '') {
			echo "&nbsp;&nbsp;<a href=\"mailto:$posterdata[pn_femail]\"><img src=\"images/global/email.gif\" border=\"0\" alt=\"\"></a><span class=\"pn-sub\">"._EMAIL."</span>\n";
		}
		if($posterdata['pn_url'] != '') {
			if(strstr("http://", $posterdata['pn_url'])) {
			$posterdata['pn_url'] = "http://" . $posterdata['pn_url'];
		}
        echo "&nbsp;&nbsp;<a href=\"" . pnVarPrepForDisplay($posterdata['pn_url']) . "\" TARGET=\"_blank\"><img src=\"images/global/www_icon.gif\" border=0 Alt=\"\"></a><span class=\"pn-sub\">www</span>\n";
    }
    if($posterdata['pn_user_icq'] != '')
        echo "&nbsp;&nbsp;<a href=\"http://wwp.icq.com/scripts/search.dll?to=" . pnVarPrepForDisplay($posterdata['pn_user_icq']) . "\" TARGET=\"_blank\"><img src=\"http://wwp.icq.com/scripts/online.dll?icq=" . pnVarPrepForDisplay($posterdata['pn_user_icq']) . "&img=5\" border=0\" Alt=\"\"></a><span class=\"pn-sub\">"._ICQ."</span>\n";
    if($posterdata["pn_user_aim"] != '')
            echo "&nbsp;&nbsp;<a href=\"aim:goim?screenname=" . pnVarPrepForDisplay($posterdata['pn_user_aim']) . "&message=Hi+" . pnVarPrepForDisplay($posterdata['pn_user_aim']) . ".+Are+you+there?\"><img src=\"images/global/aim.gif\" border=\"0\" Alt=\"\"></a><span class=\"pn-sub\">"._AIM."</span>\n";
    if($posterdata["pn_user_yim"] != '')
            echo "&nbsp;&nbsp;<a href=\"http://edit.yahoo.com/config/send_webmesg?.target=" . pnVarPrepForDisplay($posterdata['pn_user_yim']) . "&.src=pg\"><img src=\"images/global/yim.gif\" border=\"0\" Alt=\"\"></a><span class=\"pn-sub\">"._YIM."</span>\n";
    if($posterdata["pn_user_msnm"] != '')
            echo "&nbsp;&nbsp;<a href=\"user.php?op=userinfo&amp;uname=" . pnVarPrepForDisplay($posterdata['pn_uname']) . "\"><img src=\"images/global/msnm.gif\" border=\"0\" Alt=\"\"></a><span class=\"pn-sub\">"._MSNM."</span>\n";
    echo "</td></tr>"
        ."<tr bgcolor=\"$bgcolor1\" align=\"RIGHT\"><td width=20% COLSPAN=2 align=RIGHT><span class=\"pn-normal\">";
    $previous = $start-1;
    $next = $start+1;
    if ($previous >= 0) {
        echo "<a href=\"modules.php?op=modload&amp;name=$ModName&amp;file=readpmsg&amp;start=$previous&amp;total_messages=$total_messages\">"._PREVIOUSMESSAGE."</a> | ";
    } else {
        echo ""._PREVIOUSMESSAGE." | ";
    }
    if ($next < $total_messages) {
        echo "<a href=\"modules.php?op=modload&amp;name=$ModName&amp;file=readpmsg&amp;start=$next&amp;total_messages=$total_messages\">"._NEXTMESSAGE."</a></span>";
    } else {
        echo ""._NEXTMESSAGE."</span>";
    }
    echo "</td></tr>"
        ."<tr bgcolor=\"$bgcolor2\" align=\"left\"><td width=\"20%\" COLSPAN=\"2\" align=\"left\">"
        ."<span class=\"pn-normal\">|&nbsp;"
        ."<a href=\"modules.php?op=modload&amp;name=$ModName&amp;file=replypmsg&amp;reply=1&amp;msg_id=$myrow[msg_id]\"><strong>"._REPLY."</strong></a>"
        ."&nbsp;|&nbsp;<a href=\"modules.php?op=modload&amp;name=$ModName&amp;file=replypmsg&amp;delete=1&amp;msg_id=$myrow[msg_id]\"><strong>"._DELETE."</strong></a>&nbsp;|\n";
    }
    echo "</span></td></tr></table></td></tr></table>";
}
include 'footer.php';

?>